com.holonplatform.vaadin.flow.components.builders

## Interface ItemListingConfigurator.ItemListingColumnConfigurator<T,P,C extends ItemListingConfigurator.ItemListingColumnConfigurator<T,P,C>>

- Type Parameters:
    `T` - Item type
    `P` - Item property type
    `C` - Concrete configurator type
  All Superinterfaces:
    ItemListingConfigurator.BaseItemListingColumnConfigurator<C>
  All Known Subinterfaces:
    ItemListingConfigurator.ItemListingColumnBuilder<T,P,L,B>
  Enclosing interface:
    ItemListingConfigurator<T,P,L extends ItemListing<T,P>,C extends ItemListingConfigurator<T,P,L,C>>

      public static interface ItemListingConfigurator.ItemListingColumnConfigurator<T,P,C extends ItemListingConfigurator.ItemListingColumnConfigurator<T,P,C>>
      extends ItemListingConfigurator.BaseItemListingColumnConfigurator<C>

  ItemListing column configurator.
  Since:
    5.2.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `C` | `displayAfter(P afterProperty)` Configure the column to be displayed after the column which corresponds to the id specified by the given `afterProperty`.
    `C` | `displayAsFirst()` Configure the column to be displayed before any other listing column.
    `C` | `displayAsLast()` Configure the column to be displayed after any other listing column by default.
    `C` | `displayBefore(P beforeProperty)` Configure the column to be displayed before the column which corresponds to the id specified by the given `beforeProperty`.
    `default C` | `editorComponent(com.vaadin.flow.component.Component editorComponent)` Set the `Component` to display when the column is in editing mode.
    `C` | `editorComponent(Function<T,? extends com.vaadin.flow.component.Component> editorComponentProvider)` Set the `Component` to display when the column is in editing mode.
    `C` | `frozen(boolean frozen)` Set whether the column is frozen.
    `C` | `header(com.holonplatform.core.i18n.Localizable header)` Set the header text for the column.
    `default C` | `header(String header)` Set the header text for the column.
    `default C` | `header(String defaultHeader, String headerMessageCode)` Set the header text for the column.
    `C` | `headerComponent(com.vaadin.flow.component.Component header)` Set the `Component` to use as header for the column.
    `C` | `sortComparator(Comparator<T> comparator)` Sets comparator to use with in-memory sorting for the column.
    `C` | `sortProvider(Function<com.holonplatform.core.query.QuerySort.SortDirection,Stream<ItemSort<P>>> sortProvider)` Set the function to use to obtain the `ItemSort`s to use when the column is user-sorted.
    `C` | `sortUsing(List<P> sortProperties)` Set the properties to use to implement the sort logic to apply when the column is user-sorted.
    `default C` | `sortUsing(P... sortProperties)` Set the properties to use to implement the sort logic to apply when the column is user-sorted.
    `C` | `styleNameGenerator(Function<T,String> styleNameGenerator)` Set the CSS style class name generator to use for the column.

    - ### Methods inherited from interface com.holonplatform.vaadin.flow.components.builders.ItemListingConfigurator.BaseItemListingColumnConfigurator

      `alignment, autoWidth, autoWidth, flexGrow, resizable, visible, width`

- - ### Method Detail

    - #### frozen

          C frozen(boolean frozen)

      Set whether the column is frozen.
      Parameters:
        `frozen` - Whether the column is frozen
      Returns:
        this

    - #### styleNameGenerator

          C styleNameGenerator(Function<T,String> styleNameGenerator)

      Set the CSS style class name generator to use for the column.

      Returning `null` from the generator results in no custom class name being set. Multiple class names can be returned from the generator as space-separated.

      Parameters:
        `styleNameGenerator` - The function to use to generate the cell CSS style class name
      Returns:
        this
      Since:
        5.2.3

    - #### sortComparator

          C sortComparator(Comparator<T> comparator)

      Sets comparator to use with in-memory sorting for the column.
      Parameters:
        `comparator` - The comparator to use with in-memory sorting
      Returns:
        this

    - #### sortUsing

          C sortUsing(List<P> sortProperties)

      Set the properties to use to implement the sort logic to apply when the column is user-sorted.
      Parameters:
        `sortProperties` - The properties to use to sort the column
      Returns:
        this

    - #### sortUsing

          default C sortUsing(P... sortProperties)

      Set the properties to use to implement the sort logic to apply when the column is user-sorted.
      Parameters:
        `sortProperties` - The properties to use to sort the column
      Returns:
        this

    - #### sortProvider

          C sortProvider(Function<com.holonplatform.core.query.QuerySort.SortDirection,Stream<ItemSort<P>>> sortProvider)

      Set the function to use to obtain the `ItemSort`s to use when the column is user-sorted.
      Parameters:
        `sortProvider` - Sort provider
      Returns:
        this

    - #### header

          C header(com.holonplatform.core.i18n.Localizable header)

      Set the header text for the column.
      Parameters:
        `header` - Localizable column header text (not null)
      Returns:
        this

    - #### header

          default C header(String header)

      Set the header text for the column.
      Parameters:
        `header` - The column header text
      Returns:
        this

    - #### header

          default C header(String defaultHeader,
                           String headerMessageCode)

      Set the header text for the column.
      Parameters:
        `defaultHeader` - The default column header text
        `headerMessageCode` - The column header text translation message code
      Returns:
        this

    - #### headerComponent

          C headerComponent(com.vaadin.flow.component.Component header)

      Set the `Component` to use as header for the column.
      Parameters:
        `header` - The column header component
      Returns:
        this

    - #### editorComponent

          C editorComponent(Function<T,? extends com.vaadin.flow.component.Component> editorComponentProvider)

      Set the `Component` to display when the column is in editing mode.
      Parameters:
        `editorComponentProvider` - The editor component provider (not null)
      Returns:
        this

    - #### editorComponent

          default C editorComponent(com.vaadin.flow.component.Component editorComponent)

      Set the `Component` to display when the column is in editing mode.
      Parameters:
        `editorComponent` - The editor component (not null)
      Returns:
        this

    - #### displayAsFirst

          C displayAsFirst()

      Configure the column to be displayed before any other listing column.
      Returns:
        this

    - #### displayAsLast

          C displayAsLast()

      Configure the column to be displayed after any other listing column by default.
      Returns:
        this

    - #### displayBefore

          C displayBefore(P beforeProperty)

      Configure the column to be displayed before the column which corresponds to the id specified by the given `beforeProperty`.
      Parameters:
        `beforeProperty` - Property which represents the column before which this column has to be displayed (not null)
      Returns:
        this

    - #### displayAfter

          C displayAfter(P afterProperty)

      Configure the column to be displayed after the column which corresponds to the id specified by the given `afterProperty`.
      Parameters:
        `afterProperty` - Property which represents the column after which this column has to be displayed (not null)
      Returns:
        this

Copyright © 2020 The Holon Platform. All rights reserved.